<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="m-4">

  <div
    id="externalSignatureListTitle"
    class="h3"
    [innerText]="messages.EXT_SIG_TITLE">
  </div>

  <!-- Header -->

  <div class="pt-3 d-flex">

    <form class="d-flex flex-row align-items-start">

      <button
        ls-button
        (click)="onCreateButtonClicked()"
        [icon]="commonIcons.CREATE_ICON"
        [text]="messages.CONNECTOR_CREATE"
        [disabled]="!tenantId">
      </button>

    </form>

    <span class="flex-grow-1"></span>
    <span class="p-1 px-2" [innerText]="commonMessages.PAGINATION_SIZE_LABEL"></span>

    <ngb-pagination
      size="sm"
      [collectionSize]="pageSizes.length"
      [(page)]="pageSizeIndex"
      [pageSize]="1"
      [rotate]="false"
      [boundaryLinks]="false"
      [directionLinks]="false"
      (pageChange)="requestExternalConfigurationList()">
      <ng-template ngbPaginationNumber let-p>{{ getPageSize(p) }}</ng-template>
    </ngb-pagination>

  </div>

  <!-- List -->

  <table
    aria-labelledby="externalSignatureListTitle"
    class="bg-white mt-2 table table-striped border shadow-sm table-fixed table-text-overflow">

    <thead class="border">
      <tr>
        <th
          class="th-sm"
          scope="col"
          (click)="onRowOrderClicked(sortByEnum.Name)">
          <fa-icon
            class="{{ sortBy === sortByEnum.Name ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUp : caretDown"
            [fixedWidth]="true">
          </fa-icon>
          {{ commonMessages.NAME }}
        </th>
        <th
          class="th-sm col-provider-fixed-size"
          scope="col"
          [innerText]="messages.SERVICE">
        </th>
        <th
          class="th-sm col-level-fixed-size"
          scope="col"
          [innerText]="messages.SIGNATURE_LEVEL">
        </th>
        <th
          class="th-sm"
          scope="col"
          (click)="onRowOrderClicked(sortByEnum.Url)">
          <fa-icon
            class="{{ sortBy === sortByEnum.Url ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUp : caretDown"
            [fixedWidth]="true">
          </fa-icon>
          {{ messages.URL }}
        </th>
        <th
          class="th-sm"
          scope="col"
          [innerText]="messages.LOGIN">
        </th>
        <th
          *ngIf="userPreferences.showAdminIds"
          class="th-sm col-id-fixed-size"
          scope="col"
          (click)="onRowOrderClicked(sortByEnum.Id)">
          <fa-icon
            class="{{ sortBy === sortByEnum.Id ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUp : caretDown"
            [fixedWidth]="true">
          </fa-icon>
          {{ commonMessages.ID }}
        </th>
        <th
          class="col-buttons-fixed-size"
          scope="col"
          [innerText]="commonMessages.ACTIONS">
        </th>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let config of configurationList">
        <td>
          <span
            class="sortable-row"
            [innerText]="config.name | namePipe">
          </span>
        </td>
        <td>
          <span
            class="font-monospace text-size-small"
            [innerText]="config.serviceName | externalSignatureProvider">
          </span>
        </td>
        <td>
          <span
            class="font-monospace text-size-small"
            [innerText]="config.signatureLevel | externalSignatureLevel">
          </span>
        </td>
        <td>
          <span
            class="sortable-row"
            [innerText]="config.url">
          </span>
        </td>
        <td>
          <span
            class="font-monospace text-size-small"
            [innerText]="config.login">
          </span>
        </td>
        <td *ngIf="userPreferences.showAdminIds">
          <span
            class="sortable-row font-monospace text-size-small"
            [innerText]="config.id">
          </span>
        </td>
        <td class="d-flex">
          <button
            ls-button
            [style]="style.NORMAL"
            [icon]="commonIcons.EDIT_ICON"
            [ngbTooltip]="commonMessages.EDIT"
            (click)="onEditButtonClicked(config)">
          </button>
          <button
            ls-button
            class="ms-2"
            [style]="style.DANGER"
            (click)="onDeleteButtonClicked(config)"
            [ngbTooltip]="commonMessages.DELETE"
            [icon]="commonIcons.DELETE_ICON">
          </button>
        </td>
      </tr>
    </tbody>
    <tbody
      app-list-loader
      [data]="configurationList"
      [colspan]="colspan"
      [emptyMessage]="commonMessages.EMPTY_CONNECTOR_LIST"
      [loading]="loading">
    </tbody>
  </table>

  <ngb-pagination
    class="d-flex justify-content-end"
    size="sm"
    [collectionSize]="total"
    [pageSize]="getPageSize(pageSizeIndex)"
    [(page)]="page"
    [maxSize]="5"
    [rotate]="true"
    [boundaryLinks]="false"
    [directionLinks]="false"
    (pageChange)="requestExternalConfigurationList()">
  </ngb-pagination>

</div>
